/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.documentos;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteDocumentosDAO extends DocumentosDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteDocumentosDAO.class.getName());

    public SQLiteDocumentosDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<Documentos> findAll() {
        List<Documentos> documentosList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from documentos";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            documentosList = this.documentosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return documentosList;
    }

    @Override
    public Documentos findById(int id) {
        Documentos documentos = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from documentos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            List<Documentos> documentosList = this.documentosFromResultSet(rs);
            if (documentosList.size() > 0) {
                documentos = documentosList.get(0);
            }

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return documentos;
    }

    @Override
    public Documentos findByCaja(Caja caja) {
        Documentos documentos = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from documentos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            List<Documentos> documentosList = this.documentosFromResultSet(rs);
            if (documentosList.size() > 0) {
                documentos = documentosList.get(0);
            }

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return documentos;
    }

    @Override
    public boolean insertDocumentos(Documentos documentos) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into documentos (cheques, tarjetas, retiros, caja_id) values (?,?,?,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, documentos.getCheques());
            ps.setInt(2, documentos.getTarjetas());
            ps.setInt(3, documentos.getRetiros());
            ps.setInt(4, documentos.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1}, {2}, {3}, {4}] | updates: {5}", new Object[]{query, documentos.getCheques(), documentos.getTarjetas(), documentos.getRetiros(), documentos.getCaja().getId(), updates});

            ps.close();

            query = "select last_insert_rowid()";
            ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            rs.next();
            documentos.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean insertDefaultDocumentos(Documentos documentos) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into documentos (cheques, tarjetas, retiros, caja_id) values (0,0,0,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, documentos.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, documentos.getCaja().getId(), updates});

            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            rs.next();
            documentos.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateDocumentos(Documentos documentos) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update documentos set tarjetas = ?, cheques = ?, retiros = ?, caja_id = ? where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, documentos.getTarjetas());
            ps.setInt(2, documentos.getCheques());
            ps.setInt(3, documentos.getRetiros());
            ps.setInt(4, documentos.getCaja().getId());
            ps.setInt(5, documentos.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1}, {2}, {3}, {4}] | updates: {5}", new Object[]{query, documentos.getCheques(), documentos.getTarjetas(), documentos.getRetiros(), documentos.getCaja().getId(), documentos.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteDocumentos(Documentos documentos) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from documentos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, documentos.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, documentos.getCaja().getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalDocumentos(Caja caja) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select cheques + tarjetas + retiros from documentos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }
}
